#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "toolkit.h"
#include "errors.h"
#ifdef MSDOS
# include "doscmd.h"
# include "fecdef.h"
#endif
#ifdef SEDAC
# include "sedac.h"
#endif

void PreSystemInit(void);
void PostSystemInit(void);

#ifndef VXWORKS
int main(int argc, char *argv[])
{
  int cc;
  switch (argc)                           /* initial debug level */
  {           /* on UNIX or DOS stations: set debug = 1 (2,or 3) */
    case 2:              /* will dynamically set the debug level */
      NGdebug = atoi(argv[1]);
      break;
    default:
      NGdebug = 0;                              /* default level */
  }
#else
int RPCServer(void)
{
  int cc;
#endif
  printf("Server running (debug level %d)\n",NGdebug);

  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  PreSystemInit();

  /* init RPC server: */
  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }

  /* if SEDAC FEC, initialize SEDAC */
#ifdef SEDAC
# ifndef SEDAC_PORTADDR
#   define SEDAC_PORTADDR 0x300
# endif
  SedacPortAddress = SEDAC_PORTADDR;
  nSedacLines = SEDAC;
//  SedacSimulate = 1;
  initSedac();
#endif

  /* call FEC specific initialization: */
  PostSystemInit();

  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
